import es, os.path, popuplib, cPickle, cfglib, time, spe, cmdlib

'''
Todo:
    XP system
    Prestiges
    Class Design
    Better API for classes
    Events
        Will probably do events in seperate scripts to make modifing them easier
'''

info = es.AddonInfo() 
info.name = "D&D 3.5" 
info.version = "Alpha 0.1" 
info.author = "Devin Pariseau" 
info.url = "http://addons.eventscripts.com/addons/view/dnd35" 
info.description = "Level Up and gain abilities! Select race/class combo" 
es.ServerVar('dnd',info.version,'D&D 3.5 By: %s'%info.author).makepublic()

config = cfglib.AddonCFG(es.getAddonPath("dnd") + "/xp.cfg")

config.text("******************************")
config.text("  D&D SETTINGS")
config.text("*****************************")
config.text("Be careful when setting the names of commands so that they do not interfere")
config.text("with other scripts you are running")
config.text("******************************")

killxp =        config.cvar("dndkillxp",        50,             "Amount of XP for getting a kill")
headshotxp =    config.cvar("dndheadshotxp",    50,             "Amount of XP for getting a headshot")
knifexp =       config.cvar("knifexp",          50,             "Amount of XP for a knife kill")
bombplantxp =   config.cvar("bombplantxp",      60,             "Amount of XP for planting the bomb")
grenadexp =     config.cvar("grenadexp",        40,             "Amount of XP for a grenade kill")
bombxp =        config.cvar("bombxp",           100,            "Amount of XP for defusing the bomb") 
bombexxp =      config.cvar("bombexxp",         150,            "Amount of XP for the bomb exploding")
hostagexp =     config.cvar("hostagexp",        35,             "Amount of XP for rescuing a hostage")
allhostagexp =  config.cvar("allhostagexp",     70,             "Amount of XP for rescuing all hostages")
teamkillxp =    config.cvar("teamkillxp",       300,            "Amount of XP lost for killing a team mate")
zombiexp =      config.cvar("zombiexp",         95,             "Amount of XP for getting a kill while a Zombie")
killspreexp =   config.cvar("killspreexp",      10,             "Amount of XP for getting an additional kill beyond 5 without dieing")
highxp =        config.cvar("highxp",           25,             "Amount of XP for each level higher an opponent is")
roundxp =       config.cvar("roundxp",          35,             "Amount of XP for winning the round")
roundalivexp =  config.cvar("roundalivexp",     1,              "Whether or not a player must be alive for Round Won XP. 1 = Yes 0 = No")
bountyxp =      config.cvar("bountyxp",         10,             "Amount of XP bonus for killing someone with over 4 kills. Increase for every kill they get")

config.write()

es.ServerVar('dnd_debug', 1)

def dndDebug(msg):
    if int(es.ServerVar('dnd_debug')):
        es.msg('#multi', '#default', '[D&D Debug]', '#green', msg)

def dndMsg(msg):
    es.msg('#multi', '#green', '[D&D]', '#default', msg)
    
def dndTell(userid, msg=[]):
    es.tell(userid, '#multi', '#green', '[D&D]', '#default', msg)
    
menu_commands = ['wcmenu', 'wcsmenu', 'menu', 'dndmenu']

def unload():
    for userid in es.getUseridList():
        es.server.queuecmd("kickid %s 'Reloading DND mod - please reconnect'"%userid)
    saveDatabase()
    commandsToUnregister = ['!playerinfo', 'playerinfo']
    
    for command in menu_commands:
        commandsToUnregister.append(command)
        
    for command in commandsToUnregister:
        cmdlib.unregisterSayCommand(command)
        cmdlib.unregisterClientCommand(command)
        newCommand = '!' + command
        cmdlib.unregisterSayCommand(newCommand)
        cmdlib.unregisterClientCommand(newCommand)
       
def load():
    config.execute()
    try:
        loadDatabase()
    except:
        dndMsg('Failed to load database')
        
    es.reload('dnd/subscripts/player_activate')
    es.reload('dnd/subscripts/player_spawn')
    es.reload('dnd/subscripts/player_death')
    es.reload('dnd/subscripts/round_end')
    es.reload('dnd/subscripts/bomb_events')
    es.reload('dnd/subscripts/hostage_events')
    
    global main_menu, race_menu, normal_races, la_races, mainSelect, normalRaceSelect
        
    commandsToUnregister = ['!playerinfo', 'playerinfo']
    
    for command in menu_commands:
        commandsToUnregister.append(command)
        
    for command in commandsToUnregister:
        cmdlib.unregisterSayCommand(command)
        cmdlib.unregisterClientCommand(command)
        newCommand = '!' + command
        cmdlib.unregisterSayCommand(newCommand)
        cmdlib.unregisterClientCommand(newCommand)    
        
    for command in menu_commands:
        cmdlib.registerSayCommand(command, menuSend, 'Sends a menu to the player')
        cmdlib.registerClientCommand(command, menuSend, 'Sends a menu to the player')
        newCommand = '!' + command
        cmdlib.registerSayCommand(newCommand, menuSend, 'Sends a menu to the player')
        cmdlib.registerClientCommand(newCommand, menuSend, 'Sends a menu to the player')
        
    for command in ['playerinfo']:
        cmdlib.registerSayCommand(command, playerInfo, 'Sends an info menu to the player')
        cmdlib.registerClientCommand(command, playerInfo, 'Sends an info menu to the player')
        newCommand = '!' + command
        cmdlib.registerSayCommand(newCommand, playerInfo, 'Sends an info menu to the player')
        cmdlib.registerClientCommand(newCommand, playerInfo, 'Sends an info menu to the player')

    
    main_menu = popuplib.create('main_menu')
    main_menu.addline('Dungeons and Dragons CSS Main Menu:')
    main_menu.addline('-> 1. Race')
    main_menu.addline('-> 2. Class')
    main_menu.addline('-> 3. Prestige') # No prestiges at the moment
    main_menu.addline('-> 4. Info Menu') # Will probably just give info for races at selection
    main_menu.addline('-> 5. Class Weapon List') # Not defined yet
    main_menu.addline('-> 6. Stats') # Working as intended for the moment!
    main_menu.addline('-> 7. Player Menu')
    main_menu.addline('-> 0. Exit')
    main_menu.submenu(1, 'race_menu')
    main_menu.submenu(2, 'class_menu')
    main_menu.menuselect = mainSelect

    race_menu = popuplib.create('race_menu')
    race_menu.addline('Please choose what type of race you wish to be:')
    race_menu.addline('-> 1. Normal Races')
    race_menu.addline('-> 2. Level Adjustment Races')
    race_menu.addline('-> 9. Back To Main Menu')
    race_menu.addline('0. Exit')
    race_menu.submenu(1, 'normal_races')
    race_menu.submenu(2, 'la_races')
    race_menu.submenu(9, 'main_menu')
    
    normal_races = popuplib.create('normal_races')
    normal_races.addline('Dungeons and Dragons CSS Races:')
    normal_races.addline('-> 1. Human')
    normal_races.addline('-> 2. Dwarf')
    normal_races.addline('-> 3. Elf')
    normal_races.addline('-> 4. Orc')
    normal_races.addline('-> 5. Halfling')
    normal_races.addline('-> 6. Kobold')
    normal_races.addline('-> 7. Grey Elf')
    normal_races.addline('-> 9. Back To Races Menu')
    normal_races.addline('0. Exit')
    normal_races.submenu(9, 'races_menu')
    normal_races.menuselect = normalRaceSelect
    
    la_races = popuplib.create('la_races')
    la_races.addline('Dungeons and Dragons CSS Level-Adjustment Races:')
    la_races.addline('-> 9. Back To Races Menu')
    la_races.addline('0. Exit')
    la_races.submenu(9, 'races_menu')
    la_races.menuselect = laRaceSelect
    
    class_menu = popuplib.create('class_menu')
    class_menu.addline('Dungeons and Dragons CSS Classes:')
    class_menu.addline('-> 1. Fighter')
    class_menu.addline('-> 2. Cleric')
    class_menu.addline('-> 3. Rogue')
    class_menu.addline('-> 4. Sorcerer')
    class_menu.addline('-> 9. Back To Main Menu')
    class_menu.addline('0. Exit')
    class_menu.submenu(9, 'main_menu')
    class_menu.menuselect = classSelect    
    
def loadDatabase():
    global player_database
    str_path = es.getAddonPath('dnd') + '/player_database.db'
    if os.path.isfile(str_path):
        file_users = open(str_path)
        player_database = cPickle.load(file_users)
        file_users.close()
        #listDatabase()
        dndMsg('Levels loaded')
        
def saveDatabase():
    global player_database
    str_path = open(es.getAddonPath('dnd') + '/player_database.db', 'w')
    cPickle.dump(player_database, str_path)
    #listDatabase()
    str_path.close()
    dndMsg('Levels saved')
    
def playerSelection(userid, choice, popupid):
    statPlayer = Player(choice)
    statmenu = popuplib.create('statmenu_%s'%userid)
    statmenu.addline('Player Stats: %s'%es.getplayername(choice))
    statmenu.addline('  %s %s %s'%(statPlayer.getRace(), statPlayer.getLevel(), statPlayer.getClass()))
    statmenu.addline('  %s xp/%s xp'%(statPlayer.getXp(), statPlayer.getLevel() * 1000))
    statmenu.send(userid)
    popuplib.delete('statmenu_%s'%userid)
                                    
def mainSelect(userid, choice, popupid):
    if choice == 3:
        dndTell(userid, 'Currently there are no prestige classes - Please be patient')
    if choice in [4,5]:
        dndTell(userid, 'Currently adding class mechanics - Please be patient')
    if choice == 6:
        statPlayer = Player(userid)
        statmenu = popuplib.create('statmenu_%s'%userid)
        statmenu.addline('Player Stats: %s'%es.getplayername(userid))
        statmenu.addline('  %s %s %s'%(statPlayer.getRace(), statPlayer.getLevel(), statPlayer.getClass()))
        statmenu.addline('  %s xp/%s xp'%(statPlayer.getXp(), statPlayer.getLevel() * 1000))
        if statPlayer.getLevelAdjustment() > 0:
            statmenu.addline('  Level Adjustment: %s'%statPlayer.getLevelAdjustment())
        statmenu.send(userid)
        popuplib.delete('statmenu_%s'%userid)
    if choice == 7:
        es.cexec(userid, '!playerinfo')
    
    
def normalRaceSelect(userid, choice, popupid):     
    dndDebug('RaceSelect is going')
    newRace = None
    dndDebug(choice)
    if choice == 1:
        newRace = 'Human'
    if choice == 2:
        newRace = 'Dwarf'
    if choice == 3:
        newRace = 'Elf'
    if choice == 4:
        newRace = 'Orc'
    if choice == 5:
        newRace = 'Halfling'
    if choice == 6:
        newRace = 'Kobold'
    if choice == 7:
        newRace = 'Grey Elf'
    dndDebug(newRace)
    if newRace:
        Player(userid).changeRace(newRace)
                
                
def classSelect(userid, choice, popupid):
    dndDebug('classSelect is going')
    newClass = None
    dndDebug(choice)
    if choice == 1:
        newClass = 'Fighter'
    if choice == 2:
        newClass = 'Cleric'
    if choice == 3:
        newClass = 'Rogue'
    if choice == 4:
        newClass = 'Sorceror'
    dndDebug(newClass)
    if newClass:
        Player(userid).changeClass(newClass)

def laRaceSelect(userid, choice, popupid):
    pass 
    
def menuSend(userid, args):
    main_menu.send(userid)
    
def playerInfo(userid, args):
    playerMenu = popuplib.easymenu('player_menu_%s'%userid, '_popup_choice', playerSelection)
    playerMenu.settitle('Player Stat Selection')
    for player in es.getUseridList():
        playerMenu.addoption(player, es.getplayername(player))
    playerMenu.send(userid)
    popuplib.delete('player_menu_%s'%userid)

def listDatabase():
    global player_database
    dndDebug('Testing database integrity...')
    for x,y in player_database.iteritems():
        dndDebug(x)
    
class Player:
    global player_database
    def __init__(self, player):
        dndDebug('Class initialized for userid %s'%player)
        self.userid = player
        self.Player = es.getplayersteamid(player)
        self.Name   = es.getplayername(player)
        if self.Player == 'BOT':
            self.Player = self.Player + '_' + self.Name
        self.Team   = es.getplayerteam(player)
        if self.Player not in player_database:
            dndDebug('adding player %s'%self.Name)
            player_database[self.Player] = {
                                        'name'      :self.Name,
                                        'last connected':time.time(),
                                        'class'     :'Fighter',
                                        'race'      :'Human',
                                        'la'        :0,
                                        'prestige'  :0,
                                        'Fighter'   : 
                                                        {
                                                            'level' :1,
                                                            'xp'    :0
                                                        }
                                    }
            dndDebug('Player added')
            dndTell(self.userid, 'Your class and race have been automatically reset to Human Fighter')
            dndMsg('%s is new! Give them some help!'%self.Name)
        else:
            dndDebug('Player already exists')
            # Need to get players last connection
            #dndTell(player, 'Last Connected: %s'%time.ctime())
            
        if 'kills' not in player_database[self.Player]:
            player_database[self.Player]['kills'] = 0
            
    def addKills(self, kills=1):
        player_database[self.Player]['kills'] += kills
        
    def setKills(self, amount):
        player_database[self.Player]['kills'] = amount
        
    def getKills(self):
        return player_database[self.Player]['kills']
        
    def alive(self):
        dndDebug('%s %s'%(self.userid, es.getplayername(self.userid)))
        if es.getplayerprop(self.userid, 'CBasePlayer.pl.deadflag'):
            dndDebug('Is dead, flag = %s'%es.getplayerprop(self.userid, 'CBasePlayer.pl.deadflag'))
            return 0
        else:
            dndDebug('Is NOT dead, flag = %s'%es.getplayerprop(self.userid, 'CBasePlayer.pl.deadflag'))
        return 1
        
    def changeRace(self, newRace):
        if self.alive():
            dndTell(self.userid, 'You must be dead to change your race')
        else:
            player_database[self.Player]['race'] = newRace
            dndTell(self.userid, 'You are now a %s'%newRace)
            
    def changeClass(self, newClass):
        if self.alive():
            dndTell(self.userid, 'You must be dead to change your class')
        else:
            player_database[self.Player]['class'] = newClass
            if newClass not in player_database[self.Player]:
                player_database[self.Player][newClass]={
                                                            'level' :1,
                                                            'xp'    :0
                                                        }
            dndTell(self.userid, 'You are now a %s'%newClass)
    
    def getRace(self):
        return player_database[self.Player]['race']
    
    def getClass(self):
        return player_database[self.Player]['class']
        
    def getLevel(self, classLevel=None):
        if not classLevel:
            return player_database[self.Player][self.getClass()]['level']
        else:
            if classLevel not in player_database[self.Player]:
                dndDebug('ERROR - classLevel NOT IN database')
            else:
                return player_database[self.Player][classLevel]['level']
                
    def getLevelAdjustment(self):
        return player_database[self.Player]['la']
        
    def getXp(self):
        return player_database[self.Player][self.getClass()]['xp']
        
    def giveLevel(self, levels):
        player_database[self.Player][self.getClass()]['level'] += levels
        dndMsg('Congratulations, %s, for leveling up! He is now Level %s!'%(self.Name, self.getLevel()))
        
    def giveXp(self, amount, reason=None):
        count = 0
        for userid in es.getUseridList():
            if es.getplayerteam(userid) > 1:
                count += 1
        if count > 1:
            player_database[self.Player][self.getClass()]['xp'] += amount
            dndDebug('%s has %s xp'%(self.Name, self.getXp()))
            if reason:
                dndTell(self.userid, 'You have gained %s xp %s'%(amount, reason))
            else:
                dndTell(self.userid, 'You have gained %s xp'%amount)
            if self.getXp() / self.getLevel() >= 1000:
                player_database[self.Player][self.getClass()]['xp'] -= self.getLevel() * 1000
                self.giveLevel(1)
            
